

program=[[
 Integer terminator
 &($$>,&&&((>,))()&()()&&()()&()(),)()

 Integer
 &,($$>,&&&
   ($<<,&(<,)$><,(<<<,))
   ()
  &()
   ()
 &&($<<,&&(>,)&<><,$><,(<<>,)&(<,)><,)
   (&&<<,&<><,$><,(><>,)>,&!<<,><,)
  &($<<,&&(>,)><,&(<,)&<><,$><,(<>>,))
   (&&<<,&<><,$><,(>>>,)>,&?><,)
 ,)
 &&>,&(>,)<,>,&&>,&(>,)<,>,&&>,&(>,)<,>,&&>,&(>,)<,>,
 &&>,&(>,)<,>,&&>,&(>,)<,>,&&>,&(>,)<,>,&&>,&(>,)<,>,<,

 Infinite stack
 &,($$>,&(<,)(&>,&<,>,)<,)
 &($>,<,)&<,&>,&<,>,

 Infinite tape
 &($$>,&&&
   ($$<,(<,)(<<<,))
   (&&$<,(<,)$<,(>,)>, &><,&<<,>, &<,&($>,<,)&<>,>>,)
  &()
   (&<,&$>,(<,)$>,(>,) &&<>,<,>>, &&($>,<,)&<<,><,>,)
 &&(&&$<,(<,)$<,(>,)>, &&&<<<,$<<,(<<>,)><,>, &&($>,<,)&<<,><,>,)
   (&&$<,(<,)$<,(>,)>, &&&<<<,$<<,(><>,)><,>, &&($>,<,)&<<,><,>,)
  &(&&$<,(<,)$<,(>,)>, &&&<<<,$<<,(<>>,)><,>, &&($>,<,)&<<,><,>,)
   (&&$<,(<,)$<,(>,)>, &&&<<<,$<<,(>>>,)><,>, &&($>,<,)&<<,><,>,)
 <,)&,,

 Build program from input
 &,
 (
  <&,? <&,? $$?&
  (
   &,&&&(<<<,)(><<,)&(<><,)(>><,)&&(<<>,)(><>,)&(<>>,)(>>>,)
   &<,$?>, <&,? <&,? &<,$?>, &<,$?>,
   &($<<,&<>,$>,><,)&$<,<,>,
  )
  (
   <&,? <&,? <&,? &,? <&,? $$>,&
   (
    &$,,$,,
    &
    (
     &( $$$>>,(<<<,)&($<,&<,&<>,$<>,>>,)(>>,),),
     &><>,$<,&<,&<<>,>>,
     $<,>,
    ),
   )
   (())<,
  ),
 )&<,$>,>,

 Run
 $>,<,
]]


input_data="+++++++++>+++++++++>>>++++++[<+++>-]+++++++++>+++++++++>>>>>>+++++++++++++[<++++++>-]>+++++++++++[<++++++++++>-]<+>>++++++++[<++++>-]>+++++++++++[<++++++++++>-]<->>+++++++++++[<++++++++++>-]<+>>>+++++[<++++>-]<-[<++++++>-]>++++++++++[<++++++++++>-]<+>>>+++++++[<+++++++>-]>>>++++++++[<++++>-]>++++++++[<++++>-]>+++++++++++[<+++++++++>-]<->>++++++++[<++++>-]>+++++++++++[<++++++++++>-]<+>>++++++++[<++++>-]>>+++++++[<++++>-]<+[<++++>-]>++++++++[<++++>-]>>+++++++[<++++>-]<+[<++++>-]>>++++++++++++[<+++++++++>-]++++++++++>>++++++++++[<++++++++++>-]<+>>++++++++++++[<+++++++++>-]>>++++++++++++[<+++++++++>-]>>++++++[<++++>-]<-[<+++++>-]>++++++++++++[<++++++++>-]<+>>>>++++[<++++>-]<+[<+++++++>-]>++++++++[<++++>-]>++++++++[<++++>-]>+++++++++++[<++++++++++>-]<+>>++++++++++[<++++++++++>-]<+>>>++++[<++++>-]<+[<++++++>-]>+++++++++++++[<++++++++>-]>++++++++[<++++>-]>>+++++++[<++++>-]<+[<++++>-]>+++++++++++[<+++++++++>-]<->>++++++++[<++++>-]>++++++++++[<++++++++++>-]<+>>+++++++++++[<++++++++++>-]>++++++++++[<++++++++++>-]<+>>+++++++++++[<++++++++++>-]<+>>>+++++[<++++>-]<-[<++++++>-]>++++++++[<++++>-]>++++++++++>>>>++++++++++++[<+++++++>-]++++++++++>>++++++++++++[<++++++++>-]<+>>++++++++++[<++++++++++>-]>++++++++++++[<+++++++++>-]<->>+++++++++++[<++++++++++>-]>++++++++++[<++++++++++>-]<+>>+++++++++++++[<+++++++++>-]>++++++++[<++++>-]>+++++++++++[<++++++++++>-]<+>>>>+++++[<++++>-]<-[<++++++>-]>+++++++++++[<++++++++++>-]<+>>++++++++++++[<++++++++>-]<+>>+++++++++++[<++++++++++>-]>++++++++[<++++>-]>++++++++++[<++++++++++>-]<+>>>+++++++[<++++>-]<+[<++++>-]>>>+++++[<+++>-]<[<+++++++>-]>>+++++[<+++>-]<[<+++++++>-]>++++++++[<++++>-]>>+++++++[<++++>-]<+[<++++>-]>>++++++[<++++>-]<-[<+++++>-]>>>++++++[<++++>-]<-[<+++++>-]>++++++++[<++++>-]>++++++++++++[<++++++++>-]<+>>++++++++++[<++++++++++>-]>>++++[<++++>-]<[<+++++++>-]>+++++++++++[<++++++++++>-]<+>>++++++++[<++++>-]>>++++[<++++>-]<+[<+++++++>-]>++++++++++[<++++++++++>-]>+++++++++++[<++++++++++>-]>+++++++++++[<++++++++++>-]>++++++++[<++++>-]>++++++++++++[<++++++++>-]<+[<]<[<]<[<]<[<]<<<<[<]<[<]<[<]<[<]<<<<[<]<<<<<<[>>[<<[>>>+>+<<<<-]>>>[<<<+>>>-]<[>+<-]>>-[>-<[-]]>+[<+>-]<<<]>>[<<<<[-]>>>>>>>[>]>.>>>[.>>]>[>]>>[.>>]<[.<<]<[<]<<.>>>[.>>]>[>]>>[.>>]>.>>>[.>>]>[>]>>[.>>]>>[.>>]<[.<<]<<<<[<]<[<]<[<]<[<]<<<<[<]>[.>]>>>>[.>>]>>[.>>]>>[.>>]<[.<<]<[<]<<<<[<]<<-]<<<<[[-]>>>[<+>-]<<[>>+>+<<<-]>>>[<<<+>>>-]<[<<<++++++++[>++++++<-]>>>[-]]++++++++[<++++++>-]<<[.>.>]>[.>>]>>>[>]>>>>[.>>]>>[.>>]>>[.>>]<[.<<]<[<]<<<<[<]<<<<<[.>.>]>[.>>]<<<[-]>[-]>>>>>[>]>>>>[.>>]>>[.>>]>>[.>>]>.>>>[.>>]>>[.>>]>[>]>>[.>>]<[.<<]<<<<[<]<[<]<[<]<[<]<<<<[<]<<<<<<]<<[>+>+<<-]>>[<<+>>-]<[>-<[-]]>+[<+>-]<[<++++++++++<->>-]<<[>>+>+>+<<<<-]>>[<<+>>-]<-[>+>+>>+<<<<-]>[<+>-]>>>[<<[>>>+>+<<<<-]>>>[<<<+>>>-]<[>+<-]>>-[>-<[-]]>+[<+>-]<<<]>>[<<<<[-]>>>>>>>[>]>.>>>[.>>]>[>]>>[.>>]<[.<<]<[<]<<<<[<]<<-]<<<<[[-]>>>[<+>-]<<[>>+>+<<<-]>>>[<<<+>>>-]<[<<<++++++++[>++++++<-]>>>[-]]++++++++[<++++++>-]<<[.>.>]>[.>>]<<<[-]>[-]>>>>>[>]>>>>[.>>]>>[.>>]>>[.>>]<[.<<]<[<]<<<<[<]<<<<<<]++++++++++.[-]<<<[>>+>+>+<<<<-]>>[<<+>>-]<[>+>+>>+<<<<-]>[<+>-]>]"

--input_data="+[,+[-[>+>+<<-]>[<+>-]+>>++++++++[<-------->-]<-[<[-]>>>+[<+<+>>-]<[>+<-]<[<++>>>+[<+<->>-]<[>+<-]]>[<]<]>>[-]<<<[[-]<[>>+>+<<<-]>>[<<+>>-]>>++++++++[<-------->-]<->>++++[<++++++++>-]<-<[>>>+<<[>+>[-]<<-]>[<+>-]>[<<<<<+>>>>++++[<++++++++>-]>-]<<-<-]>[<<<<[-]>>>>[<<<<->>>>-]]<<++++[<<++++++++>>-]<<-[>>+>+<<<-]>>[<<+>>-]+>>+++++[<----->-]<-[<[-]>>>+[<+<->>-]<[>+<-]<[<++>>>+[<+<+>>-]<[>+<-]]>[<]<]>>[-]<<<[[-]<<[>>+>+<<<-]>>[<<+>>-]+>------------[<[-]>>>+[<+<->>-]<[>+<-]<[<++>>>+[<+<+>>-]<[>+<-]]>[<]<]>>[-]<<<<<------------->>[[-]+++++[<<+++++>>-]<<+>>]<[>++++[<<++++++++>>-]<-]>]<[-]++++++++[<++++++++>-]<+>]<.[-]+>>+<]>[[-]<]<]]november"


gl = function(a) return a[1] end gr = function(a) return a[2] end
gc = function(a,b) if(type(a)=="function") then return a(b) else return gc(a[1],{a[2],b}) end end
ov=0 obits=0 gout=function(bit) ov=ov*2+bit obits=obits+1 if(obits>7)then io.write(string.char(ov)) ov=0 obits=0 end end
gof=function(p)gc(gc(p,{function(p)gout(1)return p end,function(p)gout(0)return p end}),function(p)return p end) return p end
inchr=1 inbit=128 gi=function()local t=string.byte(input_data,inchr) if(t==nil)then return gr end t=math.floor(t/inbit)%2
inbit=inbit/2 if (inbit<1) then inbit=128 inchr=inchr+1 end if (t<1) then return gr else return gl end end
pix=1 gx=function()local i=string.sub(program,pix,pix) pix=pix+1 if(i=="&")then return"{"..gx()..","..gx().."}"end
if(i=="<")then return"gl("..gx()..")"end if(i==">")then return"gr("..gx()..")"end if(i==",")then return"v "end
if(i=="(")then return"function (v)"..gf().."return v end "end if(i==")")then return""end
if(i=="$")then return"gc("..gx()..","..gx()..")"end if(i=="!")then return"gof("..gx()..")"end if(i=="?")then return"gi()" end
return gx() end gf = function() local exp = gx() if (exp=="") then return "" else return "v="..exp..gf() end end
program = program..")" translated_program = "compiled_function = function (v) "..gf().."return v end "
v = function (p) return p end assert(loadstring(translated_program))() assert(compiled_function(v))
